// The contents of this file will be executed before any of
// your view controllers are ever executed, including the index.
// You have access to all functionality on the `Alloy` namespace.
//
// This is a great place to do any initialization for your app
// or create any global variables/functions that you'd like to
// make available throughout your app. You can easily make things
// accessible globally by attaching them to the `Alloy.Globals`
// object. For example:
//
// Alloy.Globals.someGlobalFunction = function(){};

Alloy.Globals.darkBGColor = '#5F9488';

Alloy.Globals.popupTextColor = Alloy.Globals.darkBGColor;
Alloy.Globals.popupListItemHeight = 36;
Alloy.Globals.popupListTop = '5dp';
Alloy.Globals.popupListFontSize = '26dp';

Alloy.Globals.lightBGColor = '#e4eee7';
Alloy.Globals.darkBGColor = '#5F9488';

Alloy.Globals.defaultBackgroundColor = Alloy.Globals.darkBGColor;
Alloy.Globals.windowBackgroundColor = Alloy.Globals.lightBGColor;

var platformName = Titanium.Platform.osname;
var isAndroid = (platformName == 'android');
var isIOS = (platformName == 'iphone' || platformName == 'ipad');
var isIPad = ("ipad" == platformName);

function labelWidth(sOutText, daFont)
{
	if (typeof sOutText === undefined || sOutText === null || sOutText == '')
		return 0;

	var daLabel = Ti.UI.createLabel(
	{
		font: daFont,
		color: 'black',
        backgroundColor:'transparent',
        layout: 'vertical', 
        height: 'auto',
        width: 'auto',
        text: sOutText,
        horizontalWrap: true,
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        verticalAlign: Ti.UI.TEXT_VERTICAL_ALIGNMENT_TOP
	});
    var blob = daLabel.toImage();
	var iWidth = daLabel.getSize().width;
	
	return iWidth;
}
