// --------------------------------------------------------------------------------
// Implementation by Henry David Spells III
// SpellsVentures LLC Confidential
// --------------------
// Copyright 2013 Spells Ventures LLC
//  All Rights Reserved.
// 
// NOTICE: All information contained herein is, and remains the property of
// Spells Ventures LLC and its suppliers, if any. The intellectual and technical
// concepts contained herein are proprietary to Spells Ventures LLC nd its
// suppliers and may be covered by U.S. and Foreign Patents, patents in process,
// and are protected by trade secret or copyright law. Dissemination of this
// information or reproduction of this material is strictly forbidden unless prior
// written permission is obtained from Spells Ventures LLC.
//
// --------------------------------------------------------------------------------

var win = $.PopupControl;

var _cbfn = null;
var _ndxval = -1;
function doOnClose(e)
{
	// globalEvtMgr.removeEventListener('scoretabblur', 'popup-control');
	if (_cbfn != null)
		_cbfn(_ndxval);
}

function doClose(e)
{
	if (null != win)
	{
		win.close();
		win = null;
	}
}

function doOnOpen(e)
{
	// On Android you can still click on tabs when this window is up
	// This closes the popup control window when you click on another tab
	// globalEvtMgr.addEventListener('scoretabblur', 'popup-control', doClose);
}

function clickOnNdx(section, ndx)
{
	if (_ndxval != ndx)
	{
		var item = section.getItemAt(ndx);
		item.properties.accessoryType = Ti.UI.LIST_ACCESSORY_TYPE_CHECKMARK;
		section.updateItemAt(ndx, item);
		if (_ndxval >= 0)
		{
			item = section.getItemAt(_ndxval);
	    	item.properties.accessoryType = Ti.UI.LIST_ACCESSORY_TYPE_NONE;
			section.updateItemAt(_ndxval, item);
		}
		_ndxval = ndx;
	}
}

function putIfAbsent(item, key, value)
{
	if (!(key in item))
		item[key] = value;
}

function adjustPositions(arr, center)
{
	var iMaxOptionWidth = 0;
	var iMaxIconWidth = 0;
	for (var ndx in arr)
	{
		var item = arr[ndx];
		putIfAbsent(item, 'properties', {accessoryType: Ti.UI.LIST_ACCESSORY_TYPE_NONE});
		var prop = item.properties;
		putIfAbsent(prop, 'height', Alloy.Globals.popupListItemHeight + 'dp');
		putIfAbsent(item.option, 'font', {fontFamily: 'Helvetica Neue', fontSize: Alloy.Globals.popupListFontSize});
		var iWidth = labelWidth(item.option.text, item.option.font);
		if (iWidth > iMaxOptionWidth)
			iMaxOptionWidth = iWidth;
		if ('iconBottom' in item)
		{
			putIfAbsent(item.iconBottom, 'font', {fontFamily: 'AppIcons', fontSize: Alloy.Globals.popupListFontSize});
			iWidth = labelWidth(item.iconBottom.text, item.iconBottom.font);
			if (iWidth > iMaxIconWidth)
				iMaxIconWidth = iWidth;
		}
		if ('iconTop' in item)
		{
			putIfAbsent(item.iconTop, 'font', {fontFamily: 'AppIcons', fontSize: Alloy.Globals.popupListFontSize});
			iWidth = labelWidth(item.iconTop.text, item.iconTop.font);
			if (iWidth > iMaxIconWidth)
				iMaxIconWidth = iWidth;
		}
	}
	var optionLeft = iMaxIconWidth == 0 ? 5 : 10 + iMaxIconWidth;
	// add the left side to the width with a 5 pixel border and add 50 for the checkmark
	var listWidth = optionLeft + iMaxOptionWidth + 5 + 40;
	if (center == null)
		center = {x: Ti.Platform.displayCaps.platformWidth / 2, y: measurement.dpToPX(80) };
	if (center.x < listWidth + 10)
		center.x = listWidth + 10;
	if (center.x < listWidth + 10)
		center.x = listWidth + 10;
	var lineHeight = isAndroid ? Alloy.Globals.popupListItemHeight + 2 : Alloy.Globals.popupListItemHeight;
	var listHeight = lineHeight * arr.length;
	var x = center.x;
	var y = center.y;
	$.listView.setTop(y + 'dp');
	$.listView.setLeft(x - (listWidth / 2) + 'dp');
	$.listView.setWidth(listWidth + 'dp');
	$.listView.setHeight(listHeight + 'dp');
	for (var ndx in arr)
	{
		var item = arr[ndx];
		item.option.left = optionLeft + 'dp';
		if ('iconBottom' in item)
			item.iconBottom.width = iMaxIconWidth + 'dp';
		if ('iconTop' in item)
			item.iconTop.width = iMaxIconWidth + 'dp';
	}
}

$.initialize = function(listVals, startNdx, center, cbfn)
{
	_ndxVal = -1;
	adjustPositions(listVals, center);
	$.optionsSection.setItems(listVals);
	clickOnNdx($.optionsSection, startNdx);
	_cbfn = cbfn;
};


$.listView.addEventListener('itemclick', function(e)
{
	clickOnNdx(e.section, e.itemIndex);
	doClose(e);
});
